/* MooController */

#import <Cocoa/Cocoa.h>

@interface MooController : NSObject
{
    IBOutlet NSUserDefaultsController *prefsController;
    IBOutlet NSPanel *prefsWindow;
	IBOutlet NSWindow *logWindow;

	NSAttributedString	*outputString;
	BOOL				isMooRunning;

	NSPipe				*taskStdError;
	NSPipe				*taskStdOut;
	NSTask				*task;

	NSString			*dbPath;
	
	// A bit of a misnomer... it's the filename, relative
	// to the directory that dbPath is in
	NSString			*newDbPath;
	
	BOOL				shouldPromptForDb;
}

- (NSAttributedString *) outputString;
- (void) setOutputString: (NSAttributedString *) anOutputString;
- (NSNumber*) isMooRunning;
- (void) setIsMooRunning: (NSNumber*) flag;

- (void)openPanelDidEnd:(NSOpenPanel *)panel returnCode:(int)returnCode  contextInfo:(void  *)contextInfo;
- (void)readDataNotification:(NSNotification*)aNotification;
- (void)taskEndedNotification:(NSNotification*)aNotification;

- (void)determineNewDbName;
- (void)promptUserToFindDb;
- (void)runMoo;

- (IBAction)chooseURL:(id)sender;
- (IBAction)preferences:(id)sender;
- (IBAction)startMoo:(id)sender;
- (IBAction)stopMoo:(id)sender;

- (NSPipe *) taskStdError;
- (void) setTaskStdError: (NSPipe *) aTaskStdError;
- (NSPipe *) taskStdOut;
- (void) setTaskStdOut: (NSPipe *) aTaskStdOut;
- (NSTask *) task;
- (void) setTask: (NSTask *) aTask;

- (NSString *) dbPath;
- (void) setDbPath: (NSString *) aDbPath;
- (NSString *) newDbPath;
- (void) setNewDbPath: (NSString *) aNewDbPath;

@end
